/* Software-based Trusted Platform Module (TPM) Emulator
 * Emulator Copyright (C) 2004-2010 Mario Strasser <mast@gmx.net>
 * Timing/plugin code Copyright (C) 2010-2012 Stephen R. Tate <srtate@uncg.edu>
 *
 * This module is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


/* We will stick with 160-bit HMAC keys for simplicity */

#define TPM_HMAC_KEY_LENGTH 160

/* The TPM_HMAC command is the first ordinal in the PROJ_ORACLES project */

#define TPM_ORD_HMAC TPM_SIMEXT_ORD_PROJ(TPM_SIMEXT_PROJ_ORACLES,1)

/*
 * PARMS structure just holds the key length - for now fixed at 160,
 * but defined here as a parameter to allow future modifications.
 */
typedef struct tdTPM_HMAC_KEY_PARMS {
  UINT32 keyLength;
} TPM_HMAC_KEY_PARMS;

/*
 * The actual HMAC key is just an array of bytes...
 */
typedef struct tpm_hmac_key_s {
  BYTE key[(TPM_HMAC_KEY_LENGTH+7)/8];
} tpm_hmac_key_t;

/*
 * extern definition so hmac key table can be loaded at plugin init.
 */
extern keytype_info hmac_info;

